/**
 * 
 */

var selectionData = Titanium.App.Properties.getList("recipeList");

var recipeSelectionTable = Titanium.UI.createTableView();
var recipeSelectionList = [];

var shoppingListTable = Titanium.UI.createTableView({ data : [] });
var shoppingListTableWindow = Titanium.UI.createWindow({
	title : "Deine Einkaufsliste"
});
shoppingListTableWindow.add(shoppingListTable);

var shoppingListTableInstructionView = Titanium.UI.createView({height: "auto"});
var shoppingListTableInstructionLabel = Titanium.UI.createLabel({
	text: "Wähle alle Cocktails aus, die du auf deiner Party anbieten willst und drücke \"Generieren\".",
	top: 5,
	bottom: 5,
	right: 5,
	left: 5,
	height: 60
});

var generateButton = Titanium.UI.createButton({
	title: "Generieren"
});
generateButton.addEventListener('click', function(){
	
	shoppingListTable.setData([],{});
	
	var shoppingListData = [];
	
	for(var i = 0; i < recipeSelectionList.length; i++){
		if(recipeSelectionList[i] == true && selectionData[i].ingredientArray != null){
			for(var j = 0; j < selectionData[i].ingredientArray.length; j++){
				shoppingListData.push({title: selectionData[i].ingredientArray[j]});
			}
		}
	}
	
	function sortfunction(a, b){
		var nameA=a.title.toLowerCase(), nameB=b.title.toLowerCase();
		if (nameA < nameB){ // sort string ascending
			return -1;
		}
		if (nameA > nameB){
			return 1;
		}
		return 0; // default return value (no sorting)
	}
	
	shoppingListData.sort(sortfunction);
	
	function removeDuplicates(array){
		// needs sorted array
		var result = [];
	    var lastValue = "";
	    for (var i=0; i < array.length; i++){
	 	  var currentValue = array[i];
	 	  if (currentValue.title != lastValue){
	 		 result[result.length] = currentValue;
	 	  }
	 	  lastValue = currentValue.title;
	    }
	    return result;
	}
	
	shoppingListData = removeDuplicates(shoppingListData);
	
	shoppingListTable.setData(shoppingListData,{});

	shoppingListTab.open(shoppingListTableWindow);
});


shoppingListTableInstructionView.add(shoppingListTableInstructionLabel);
if (Titanium.Platform.osname == 'android'){
	generateButton.right = 5;
	generateButton.top = 5;
	generateButton.bottom = 5;
	generateButton.width = 100;
	
	shoppingListTableInstructionLabel.right = 105;
	shoppingListTableInstructionLabel.height = 60;
	
	shoppingListTableInstructionView.add(generateButton);
} else {
	shoppingListWindow.rightNavButton = generateButton;
	
}

recipeSelectionTable.headerView = shoppingListTableInstructionView;

for (var i = 0; i < selectionData.length; i++){
	
	var recipeSelectionRow = Titanium.UI.createTableViewRow({height: 'auto'});
	recipeSelectionRow.data=selectionData[i];
	recipeSelectionList[i] = false;
	
	var recipeName = Titanium.UI.createLabel({
	    text:selectionData[i].name,
	    height:'auto'
	});
	
	var ingredients = Titanium.UI.createLabel({
	    text:selectionData[i].ingredients,
	    color: '#888888',
	    font:{fontSize:12},
	    height:'auto'
	});
	
	if (Titanium.Platform.osname == 'android'){
		var basicSwitch1 = Titanium.UI.createSwitch({
			value:false,
			left: 5,
			top: 5
		});
		basicSwitch1.style = Ti.UI.Android.SWITCH_STYLE_CHECKBOX;
		recipeName.left = 50;
		recipeName.top = 5;
		recipeName.right = 5;
		ingredients.top = 20;
		ingredients.left = 50;
		ingredients.right = 5;
		ingredients.checkbox = basicSwitch1;
		recipeName.checkbox = basicSwitch1;
		recipeSelectionRow.checkbox = basicSwitch1;
		recipeSelectionRow.add(basicSwitch1);
		recipeSelectionRow.addEventListener('click',function(e) {
			if(e.source.checkbox != null){
				e.source.checkbox.value = !e.source.checkbox.value;
				recipeSelectionList[e.index] = !recipeSelectionList[e.index];
			}
		});
	} else {
		recipeName.top = 5;
		recipeName.left = 5;
		recipeName.right = 15;
		ingredients.top = 30;
		ingredients.left = 5;
		ingredients.bottom = 10;
		ingredients.right = 15;
		recipeName.parent = recipeSelectionRow;
		ingredients.parent = recipeSelectionRow;
		recipeSelectionRow.hasCheck = false;
		recipeSelectionRow.addEventListener('click',function(e) {
			if(e.source.parent != null){
				e.source.parent.hasCheck = !e.source.parent.hasCheck;
				recipeSelectionList[e.index] = !recipeSelectionList[e.index];
			} else {
				recipeSelectionList[e.index] = !recipeSelectionList[e.index];
			}
			e.source.hasCheck = !e.source.hasCheck;
		});
	}
	
	recipeSelectionRow.add(recipeName);
	recipeSelectionRow.add(ingredients);
	recipeSelectionTable.appendRow(recipeSelectionRow);
}

shoppingListWindow.add(recipeSelectionTable);
